' ***************************** EQUIP.BAS  ****************************
'
'                    ۿ ۿ ۿ ۿ
'                    ۳  ۳ 
'                     ۳  ۳  ۳  ۳ ۿ
'                     ۳  ۳  ۳  ۳ ۳
'                    ۳ ۿ ۳ ۳
'                       
'
'
' ߱
'             ܱ 
'     ߱     ߱ ۱۱  ۱۱  ߱
'             ۱۱    ۱۱    
'     ۱ ܱ      ߱    ۱۱    
'              ۱    
'   ߱                          
'
'
'
'JRD NOTE:
'
'Get equip list as preamble to switching the math coprocessor on
'and off
'
'RUN in QBASIC.EXE (Version 1.1, comes with DOS 5.0 or newer)
'with the command:
'
'QBASIC /RUN EQUIP.BAS
'
'General Outline of this program scanned from:
'QuickBASIC Bible: CHAPTER 19: Port and Memory, page 717
'
'1/10/95
'---------------------------------------------------------------------
'defines, declares and constants next
DEFINT A-Z
DECLARE FUNCTION Sint% (num&)
DECLARE FUNCTION BitTest% (number%, bit%)
DECLARE SUB WaitKey ()
CONST TABLEN = 37
CONST BaseRow% = 2

'executable code next
'an old styled (but fast) FUNCTION, returns the column
'to locate a centered text string.
DEF FNCenter% (text$) = 41 - (LEN(text$) \ 2)
REDIM Bytes%(15)                 'makes array dynamic

DEF SEG = &H40                   'BIOS memory address
LowByte% = PEEK(&H10)            'low byte
Hibyte% = PEEK(&H11)             'High byte of equipment list
DEF SEG                          'back to DGROUP

LongEquipNum& = LowByte% + (Hibyte% * 256)  'make a two byte LONG integer
'use a FUNCTION to return a 2 byte INTEGER (signed) we can "byte"
Equipment% = Sint%(LongEquipNum&)

Flag$ = STRING$(16, "O")         'set up binary string as all zeros
FOR i% = 15 TO 0 STEP -1
	IF BitTest%(Equipment%, i%) THEN
		MID$(Flag$, 16 - i%, 1) = "1"
		Bytes%(i%) = 1
	END IF

NEXT i%

COLOR 15, 1
CLS
COLOR 15, 4
text$ = " ROM BIOS Startup Equipment List "
LOCATE BaseRow%, FNCenter%(text$): PRINT text$;

COLOR 14, 1
text2$ = "< The 16 Bits of the -2 Byte- Equipment% Number >"
LOCATE BaseRow% + 2, FNCenter%(text2$): PRINT text2$;

COLOR 15, 1
text2$ = "F E D C B A 9 8 7 6 5 4 3 2 1 0"
LOCATE BaseRow% + 4, FNCenter%(text$): PRINT text2$;

text2$ = STRING$(32, CHR$(196))
LOCATE BaseRow% + 5, FNCenter%(text$): PRINT text2$;

LOCATE BaseRow% + 6, FNCenter%(text2$) - 1
FOR i% = 1 TO 16: PRINT MID$(Flag$, i%, 1); " ";
NEXT
LOCATE BaseRow% + 7, FNCenter%(text$): PRINT text2$
PRINT
text2$ = "ROM BIOS equipment list at 0040:0010"
PRINT text2$

text2$ = STRING$(51, CHR$(196))
PRINT text2$
PRINT "Byte  Description"; TAB(TABLEN); "Result/Number"
text2$ = STRING$(51, CHR$(196))
PRINT text2$

'STOP
'Data for below from Norton's Programmer's Bible, page 66
IF Bytes%(0) = 1 THEN
	IsFloppy$ = "Yes"
ELSE
	IsFloppy$ = "No"
END IF
PRINT "O     Floppy drives installed?"; TAB(TABLEN); IsFloppy$

IF Bytes%(1) = 1 THEN
	IsMath$ = "Yes"
ELSE
	IsMath$ = "No"
END IF
PRINT "1     Math coprocessor installed?"; TAB(TABLEN); IsMath$

SELECT CASE Bytes%(3)
			CASE 0
				SELECT CASE Bytes%(4)
					CASE 0
						RAM$ = "16KB"
					CASE 1
						RAM$ = "48KB"
				 END SELECT
			CASE 1
				SELECT CASE Bytes%(4)
					CASE 0
						RAM$ = "32KB"
					CASE 1
						RAM$ = "64KB"
				 END SELECT
END SELECT
PRINT "2-3   IF 1982 PC Motherboard RAM"; TAB(TABLEN); RAM$

SELECT CASE Bytes%(4)
			CASE 0
				SELECT CASE Bytes%(5)
					CASE 0
						VideoMode$ = "Unknown"
					CASE 1
						VideoMode$ = "80 Column Color"
				 END SELECT
			CASE 1
				SELECT CASE Bytes%(5)
					CASE 0
						VideoMode$ = "40 Column Color"
					CASE 1
						VideoMode$ = "80 Column MonoChrome"
				 END SELECT
END SELECT
PRINT "4-5   Initial video mode"; TAB(TABLEN); VideoMode$

IF Bytes%(0) = 1 THEN
	Drives% = Bytes%(0) + Bytes%(6) + Bytes%(7)
ELSE
	Drives% = Bytes%(6) + Bytes%(7)
END IF
PRINT "6-7   Number of floppy drives"; TAB(TABLEN); Drives%

PRINT "9-B   Number of serial ports"; TAB(TABLEN); Bytes%(9) + Bytes%(10) + Bytes%(11)
PRINT "C     Game adapter installed?"; TAB(TABLEN); Bytes%(12)
PRINT "E-F   Number of parallel printers"; TAB(TABLEN); Bytes%(14) + Bytes%(15)
CALL WaitKey
COLOR 7, 0
END

FUNCTION BitTest% (number%, bit%)

	 'extract a bit from the number
	 'JRD NOTE: an obscure way to get "True" or -1
	 'use - SGN if bit is 1 then is -1
	 BitTest% = -SGN(number% AND 2 ^ bit%)

END FUNCTION

FUNCTION Sint% (num&)
	 'if  the PEEK address is a
	 'number > 32767 or < -32768, this fixes that
	 Sint% = -((num& > 32767) * (num& - 65536)) - ((num& < 32768) * num&)
END FUNCTION

SUB WaitKey
	StoreRow% = CSRLIN
	StoreCol% = POS(0)
	COLOR 11, 0
	text2$ = "PRESS: A key to END....."
	LOCATE 24, FNCenter%(text2$)
	PRINT text2$;
	WHILE INKEY$ = "": WEND
	WHILE INKEY$ <> "": WEND
	LOCATE StoreRow%, StoreCol%
END SUB

